part of geoclip;

/**
 * Intersection table
 */
class _ItNode {
  // [2] Intersecting edge (bundle) pair
  List<_EdgeNode> ie = new List<_EdgeNode>(2);
  // Point of intersection
  GPoint point = new GPoint.zero();
  // The next intersection table node
  _ItNode next;

  _ItNode(_EdgeNode edge0, _EdgeNode edge1, double x, double y, _ItNode next) {
    this.ie[0] = edge0;
    this.ie[1] = edge1;
    this.point.x = x;
    this.point.y = y;
    this.next = next;
  }
}

class _ItNodeTable {
  _ItNode top_node;

  void build_intersection_table(_AetTree aet, double dy) {
    _StNode st = null;

    // Process each AET edge */
    for (_EdgeNode edge = aet.top_node; (edge != null); edge = edge.next) {
      if ((edge.bstate[Boolean.ABOVE] == BundleState.BUNDLE_HEAD) ||
          (edge.bundle[Boolean.ABOVE][Boolean.CLIP] != 0) ||
          (edge.bundle[Boolean.ABOVE][Boolean.SUBJ] != 0)) {
        st = Boolean._add_st_edge(st, this, edge, dy);
      }
    }
  }
}

/**
 * Sorted edge table
 */
class _StNode {
  // Pointer to AET edge
  _EdgeNode edge;
  // Scanbeam bottom x coordinate
  double xb;
  // Scanbeam top x coordinate
  double xt;
  // Change in x for a unit y increase
  double dx;
  // Previous edge in sorted list
  _StNode prev;

  _StNode(_EdgeNode edge, _StNode prev) {
    this.edge = edge;
    this.xb = edge.xb;
    this.xt = edge.xt;
    this.dx = edge.dx;
    this.prev = prev;
  }
}
