part of geoclip;

/**
  * Internal contour / tristrip type
  */
class _PolygonNode {
  // Active flag / vertex count
  int active;
  // Hole / external contour flag
  bool hole;
  //[2] Left and right vertex list ptrs
  List<_VertexNode> v = new List<_VertexNode>(2);
  // next polygon contour
  _PolygonNode next;
  // actual structure used
  _PolygonNode proxy;

  _PolygonNode(_PolygonNode next, double x, double y) {
    // Make v[LEFT] and v[RIGHT] point to new vertex
    _VertexNode vn = new _VertexNode(x, y);
    this.v[Boolean.LEFT] = vn;
    this.v[Boolean.RIGHT] = vn;

    this.next = next;
    this.proxy = this;
    // Initialise proxy to point to p itself
    this.active = 1; //TRUE
  }

  void add_right(double x, double y) {
    _VertexNode nv = new _VertexNode(x, y);

    // Add vertex nv to the right end of the polygon's vertex list
    proxy.v[Boolean.RIGHT].next = nv;

    // Update proxy->v[RIGHT] to point to nv
    proxy.v[Boolean.RIGHT] = nv;
  }

  void add_left(double x, double y) {
    _VertexNode nv = new _VertexNode(x, y);

    // Add vertex nv to the left end of the polygon's vertex list
    nv.next = proxy.v[Boolean.LEFT];

    // Update proxy->[LEFT] to point to nv
    proxy.v[Boolean.LEFT] = nv;
  }

}
