part of geoclip;

class GPoint {
  static const num _EPSILON = 0.000001;

  double x;
  double y;

  GPoint(this.x, this.y);
  
  GPoint.zero() {
    this.x = 0.0;
    this.y = 0.0;
  }

  GPoint.fromCoords(this.x, this.y);

  GPoint.fromPoint(GPoint dp) {
    this.x = dp.x;
    this.y = dp.y;
  }

  void set(GPoint other) {
    x = other.x;
    y = other.y;
  }

  GPoint operator-(GPoint other) {
    return new GPoint(x - other.x, y - other.y);
  }
  
  GPoint operator+(GPoint other) {
    return new GPoint(x + other.x, y + other.y);
  }
  
  bool operator==(GPoint other) {
    // TODO see this article about a more robust equality check
    // http://floating-point-gui.de/errors/comparison/
    return ((x - other.x).abs() < _EPSILON) && ((y - other.y).abs() < _EPSILON);
  }

  GPoint operator*(double s) {
    return new GPoint(x * s, y * s);
  }
  
  @override
  String toString() {
    return "($x, $y)";
  }
}


class GRectangle {
  double x;
  double y;
  double width;
  double height;
  
  GRectangle(this.x, this.y, this.width, this.height);
  
  GRectangle.zero() {
    x = y = width = height = 0.0;
  }
  
  double get minX => x;
  double get minY => y;
  double get maxX => x + width;
  double get maxY => y + height;
  
}

