part of geoclip;

/**
 * Scanbeam tree 
 */
class _ScanBeamTree {
  // Scanbeam node y value
  double y;
  // Pointer to nodes with lower y
  _ScanBeamTree less;
  // Pointer to nodes with higher y
  _ScanBeamTree more;

  _ScanBeamTree(this.y);
}

class _ScanBeamTreeEntries {
  int sbt_entries = 0;
  _ScanBeamTree sb_tree;

  List<double> build_sbt() {
    List<double> sbt = new List<double>(sbt_entries);//[sbt_entries]

    int entries = 0;
    entries = inner_build_sbt(entries, sbt, sb_tree);
    if (entries != sbt_entries) {
      throw new Exception("Something went wrong building scan beam tree from tree.");
    }
    return sbt;
  }

  int inner_build_sbt(int entries, List<double> sbt, _ScanBeamTree sbt_node) {
    if (sbt_node.less != null) {
      entries = inner_build_sbt(entries, sbt, sbt_node.less);
    }
    sbt[entries] = sbt_node.y;
    entries++;
    if (sbt_node.more != null) {
      entries = inner_build_sbt(entries, sbt, sbt_node.more);
    }
    return entries;
  }
}
