part of geoclip;

double distanceBetweenByDouble(double p0X, double p0Y, double p1X, double p1Y) {
  double dx = p0X - p1X;
  double dy = p0Y - p1Y;
  return sqrt(dx * dx + dy * dy);
}

/**
 * [x] and [y] is the point.
 * [x1, y1, x2, y2] is the line segment.
 */
double pointToLineDistance(double x, double y, double x1, double y1, double x2, double y2) {
  double A = x - x1;
  double B = y - y1;
  double C = x2 - x1;
  double D = y2 - y1;

  double dot = A * C + B * D;
  double len_sq = C * C + D * D;
  double param = dot / len_sq;

  double xx, yy;

  if (param < 0.0 || (x1 == x2 && y1 == y2)) {
      xx = x1;
      yy = y1;
  }
  else if (param > 1.0) {
      xx = x2;
      yy = y2;
  }
  else {
      xx = x1 + param * C;
      yy = y1 + param * D;
  }

  double dx = x - xx;
  double dy = y - yy;

  return sqrt(dx * dx + dy * dy);
}
