part of geoclip;

/**
  * Internal vertex list datatype
  */
class _VertexNode {
  double x; // X coordinate component
  double y; // Y coordinate component
  _VertexNode next; // Pointer to next vertex in list

  _VertexNode(this.x, this.y);
}

/**
 * Edge intersection classes
 */
class _VertexType {
  //static const int NUL =  0 ; // Empty non-intersection
  // External maximum
  static const int EMX = 1;
  // External left intermediate
  static const int ELI = 2;
  //static const int TED =  3 ; // Top edge
  // External right intermediate
  static const int ERI = 4;
  // Right edge
  static const int RED = 5;
  // Internal maximum and minimum
  static const int IMM = 6;
  // Internal minimum
  static const int IMN = 7;
  // External minimum
  static const int EMN = 8;
  // External maximum and minimum
  static const int EMM = 9;
  // Left edge
  static const int LED = 10;
  // Internal left intermediate
  static const int ILI = 11;
  //static const int BED = 12 ; // Bottom edge
  // Internal right intermediate
  static const int IRI = 13;
  // Internal maximum
  static const int IMX = 14;
  //static const int FUL = 15 ; // Full non-intersection

  static int getType(int tr, int tl, int br, int bl) {
    return tr + (tl << 1) + (br << 2) + (bl << 3);
  }
}
