library caster_strip;

import 'dart:html';
import 'caster_edge.dart';

/*
This object is the results of scanning a polygon.
 */
class CasterStrip {
  int edges = 0;
  bool added = false;
  CasterEdge start;
  CasterEdge end;
  
  void draw(CanvasRenderingContext2D context, String color) {
    CasterEdge next = start;
    
    context..save()
      ..lineWidth = 10
      ..strokeStyle = color
      ..beginPath();
    
    if (start == end) {
      context..moveTo(next.v0.x, next.v0.y)
      ..lineTo(next.v1.x, next.v1.y)
      ..stroke();
    }
    else if (end != null) {
      do {
          context..moveTo(next.v0.x, next.v0.y)
          ..lineTo(next.v1.x, next.v1.y);
        next = next.nextEdge;
      } while (next != end);
      
      context..moveTo(next.v0.x, next.v0.y)
      ..lineTo(next.v1.x, next.v1.y)
      ..stroke();
    }
    else {
      context..moveTo(next.v0.x, next.v0.y)
      ..lineTo(next.v1.x, next.v1.y)
      ..stroke();
    }
    
    context.restore();
  }
  
  @override
  String toString() {
    StringBuffer s = new StringBuffer();
    CasterEdge next = start;
    
    if (start == end) {
      s.write("{${next.v0},${next.v1}},");
    }
    else if (end != null) {
      do {
        s.write("{${next.v0},${next.v1}},");
        next = next.nextEdge;
      } while (next != end);
      s.write("{${next.v0},${next.v1}},");
    }
    else {
      s.write("{${next.v0},${next.v1}},");
    }
    return s.toString();
  }
}
